_USBInterrupt:
;USB_Driver.c,22 :: 		void USBInterrupt() iv IVT_INT_OTG_FS ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_Driver.c,23 :: 		USB_Interrupt_Proc();
BL	_USB_Interrupt_Proc+0
;USB_Driver.c,24 :: 		}
L_end_USBInterrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USBInterrupt
_USB_Init:
;USB_Driver.c,28 :: 		void USB_Init(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_Driver.c,32 :: 		HID_Enable(&readbuff,&writebuff);
MOVW	R1, #lo_addr(_writebuff+0)
MOVT	R1, #hi_addr(_writebuff+0)
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
BL	_HID_Enable+0
;USB_Driver.c,33 :: 		USB_TxQueueInit();
BL	_USB_TxQueueInit+0
;USB_Driver.c,35 :: 		}
L_end_USB_Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USB_Init
_USB_TxQueueInit:
;USB_Driver.c,39 :: 		void USB_TxQueueInit(void) {
;USB_Driver.c,40 :: 		USB_Queue.in = 0;
MOVW	R1, #0
MOVW	R0, #lo_addr(_USB_Queue+0)
MOVT	R0, #hi_addr(_USB_Queue+0)
STRH	R1, [R0, #0]
;USB_Driver.c,41 :: 		USB_Queue.out = 0;
MOVW	R1, #0
MOVW	R0, #lo_addr(_USB_Queue+2)
MOVT	R0, #hi_addr(_USB_Queue+2)
STRH	R1, [R0, #0]
;USB_Driver.c,42 :: 		}
L_end_USB_TxQueueInit:
BX	LR
; end of _USB_TxQueueInit
_USB_PutQueue:
;USB_Driver.c,47 :: 		void USB_PutQueue(char *msg) {
;USB_Driver.c,48 :: 		USB_Queue.q[USB_Queue.in++] = msg;
MOVW	R0, #lo_addr(_USB_Queue+0)
MOVT	R0, #hi_addr(_USB_Queue+0)
LDRH	R1, [R0, #0]
MOV	R0, #4
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_USB_Queue+4)
MOVT	R0, #hi_addr(_USB_Queue+4)
ADDS	R1, R0, R1
LDR	R0, [SP, #0]
STR	R0, [R1, #0]
MOVW	R0, #lo_addr(_USB_Queue+0)
MOVT	R0, #hi_addr(_USB_Queue+0)
LDRH	R0, [R0, #0]
ADDS	R1, R0, #1
MOVW	R0, #lo_addr(_USB_Queue+0)
MOVT	R0, #hi_addr(_USB_Queue+0)
STRH	R1, [R0, #0]
;USB_Driver.c,49 :: 		if (USB_Queue.in > (USB_Queue_Size-1))
MOVW	R0, #lo_addr(_USB_Queue+0)
MOVT	R0, #hi_addr(_USB_Queue+0)
LDRH	R0, [R0, #0]
CMP	R0, #63
IT	LE
BLE	L_USB_PutQueue0
;USB_Driver.c,50 :: 		USB_Queue.in = 0;
MOVW	R1, #0
MOVW	R0, #lo_addr(_USB_Queue+0)
MOVT	R0, #hi_addr(_USB_Queue+0)
STRH	R1, [R0, #0]
L_USB_PutQueue0:
;USB_Driver.c,51 :: 		}
L_end_USB_PutQueue:
BX	LR
; end of _USB_PutQueue
_USB_CheckOut:
;USB_Driver.c,59 :: 		void USB_CheckOut(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_Driver.c,62 :: 		if (USB_Queue.in != USB_Queue.out) {          // Look for a pointer in the FIFO
MOVW	R0, #lo_addr(_USB_Queue+2)
MOVT	R0, #hi_addr(_USB_Queue+2)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_USB_Queue+0)
MOVT	R0, #hi_addr(_USB_Queue+0)
LDRH	R0, [R0, #0]
CMP	R0, R1
IT	EQ
BEQ	L_USB_CheckOut1
;USB_Driver.c,64 :: 		if (HID_Write(USB_Queue.q[USB_Queue.out],64) != 0) {
MOVW	R0, #lo_addr(_USB_Queue+2)
MOVT	R0, #hi_addr(_USB_Queue+2)
LDRH	R1, [R0, #0]
MOV	R0, #4
MULS	R1, R0, R1
MOVW	R0, #lo_addr(_USB_Queue+4)
MOVT	R0, #hi_addr(_USB_Queue+4)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
MOV	R4, R0
MOVS	R1, #64
MOV	R0, R4
BL	_HID_Write+0
CMP	R0, #0
IT	EQ
BEQ	L_USB_CheckOut2
;USB_Driver.c,65 :: 		USB_Queue.out++;
MOVW	R0, #lo_addr(_USB_Queue+2)
MOVT	R0, #hi_addr(_USB_Queue+2)
LDRH	R0, [R0, #0]
ADDS	R1, R0, #1
MOVW	R0, #lo_addr(_USB_Queue+2)
MOVT	R0, #hi_addr(_USB_Queue+2)
STRH	R1, [R0, #0]
;USB_Driver.c,66 :: 		if (USB_Queue.out > (USB_Queue_Size-1))  // If past the end of array
MOVW	R0, #lo_addr(_USB_Queue+2)
MOVT	R0, #hi_addr(_USB_Queue+2)
LDRH	R0, [R0, #0]
CMP	R0, #63
IT	LE
BLE	L_USB_CheckOut3
;USB_Driver.c,67 :: 		USB_Queue.out = 0;                   // set pointer to start of array
MOVW	R1, #0
MOVW	R0, #lo_addr(_USB_Queue+2)
MOVT	R0, #hi_addr(_USB_Queue+2)
STRH	R1, [R0, #0]
L_USB_CheckOut3:
;USB_Driver.c,68 :: 		}
L_USB_CheckOut2:
;USB_Driver.c,69 :: 		}
L_USB_CheckOut1:
;USB_Driver.c,70 :: 		}
L_end_USB_CheckOut:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USB_CheckOut
_USB_CheckIn:
;USB_Driver.c,76 :: 		void USB_CheckIn(void) {
SUB	SP, SP, #16
STR	LR, [SP, #0]
;USB_Driver.c,80 :: 		if (HID_Read() != 0) {
BL	_HID_Read+0
CMP	R0, #0
IT	EQ
BEQ	L_USB_CheckIn4
;USB_Driver.c,81 :: 		switch (readbuff[0]) {
IT	AL
BAL	L_USB_CheckIn5
;USB_Driver.c,83 :: 		case 'a':  // Test to make sure USB is working
L_USB_CheckIn7:
;USB_Driver.c,84 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;USB_Driver.c,85 :: 		sprintf(BufNum,"Command a received\r\n");
MOVW	R0, #lo_addr(?lstr_1_USB_Driver+0)
MOVT	R0, #hi_addr(?lstr_1_USB_Driver+0)
PUSH	(R0)
LDR	R0, [SP, #8]
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #8
;USB_Driver.c,86 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
PUSH	(R0)
BL	_USB_PutQueue+0
ADD	SP, SP, #4
;USB_Driver.c,87 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,88 :: 		case 'b':  // Test from help file for atan2
L_USB_CheckIn8:
;USB_Driver.c,89 :: 		Temp1 = atan2(2., 1.);  // Temp1 = 4.636475e-1
VMOV.F32	S1, #1
VMOV.F32	S0, #2
BL	_atan2+0
VMOV	R0, S0
BL	__FloatToLongDouble+0
STRD	R0, R1, [SP, #8]
;USB_Driver.c,90 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;USB_Driver.c,91 :: 		FloatToStr(Temp1,BufNum);
VLDR	#1, D0, [SP, #8]
VMOV	R0, S0
VMOV	R1, S1
BL	__LongDoubleToFloat+0
VMOV	S0, R0
LDR	R0, [SP, #4]
BL	_FloatToStr+0
;USB_Driver.c,92 :: 		strcat(BufNum,"\r\n");
MOVW	R4, #lo_addr(?lstr2_USB_Driver+0)
MOVT	R4, #hi_addr(?lstr2_USB_Driver+0)
MOV	R1, R4
LDR	R0, [SP, #4]
BL	_strcat+0
;USB_Driver.c,93 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
PUSH	(R0)
BL	_USB_PutQueue+0
ADD	SP, SP, #4
;USB_Driver.c,95 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,96 :: 		case 'c':  // Example of problem compilation by mikroC
L_USB_CheckIn9:
;USB_Driver.c,97 :: 		MyTest2();
BL	_MyTest2+0
;USB_Driver.c,98 :: 		USB_PutQueue("Done\r\n");
MOVW	R0, #lo_addr(?lstr3_USB_Driver+0)
MOVT	R0, #hi_addr(?lstr3_USB_Driver+0)
PUSH	(R0)
BL	_USB_PutQueue+0
ADD	SP, SP, #4
;USB_Driver.c,99 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,100 :: 		case 'd':
L_USB_CheckIn10:
;USB_Driver.c,101 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,102 :: 		case 'e':
L_USB_CheckIn11:
;USB_Driver.c,103 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,104 :: 		case 'f':
L_USB_CheckIn12:
;USB_Driver.c,105 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,106 :: 		case 'g':
L_USB_CheckIn13:
;USB_Driver.c,107 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,108 :: 		case 'h':
L_USB_CheckIn14:
;USB_Driver.c,109 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,110 :: 		case 'i':
L_USB_CheckIn15:
;USB_Driver.c,111 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,112 :: 		case 'j':
L_USB_CheckIn16:
;USB_Driver.c,113 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,114 :: 		case 'k':
L_USB_CheckIn17:
;USB_Driver.c,115 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,116 :: 		case 'l':
L_USB_CheckIn18:
;USB_Driver.c,117 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,118 :: 		case 'm':
L_USB_CheckIn19:
;USB_Driver.c,119 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,120 :: 		case 'n':
L_USB_CheckIn20:
;USB_Driver.c,121 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,122 :: 		case 'o':
L_USB_CheckIn21:
;USB_Driver.c,123 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,124 :: 		case 'p':
L_USB_CheckIn22:
;USB_Driver.c,125 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,126 :: 		case 'q':
L_USB_CheckIn23:
;USB_Driver.c,127 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,128 :: 		case 'r':
L_USB_CheckIn24:
;USB_Driver.c,129 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,130 :: 		case 's':  // Execute standard spa test and sends results to USB terminal
L_USB_CheckIn25:
;USB_Driver.c,131 :: 		SPA_Test();
BL	_SPA_Test+0
;USB_Driver.c,132 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,133 :: 		case 't':
L_USB_CheckIn26:
;USB_Driver.c,134 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,135 :: 		case 'u':
L_USB_CheckIn27:
;USB_Driver.c,136 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,137 :: 		case 'v':
L_USB_CheckIn28:
;USB_Driver.c,138 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,139 :: 		case 'w':
L_USB_CheckIn29:
;USB_Driver.c,140 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,141 :: 		case 'x':
L_USB_CheckIn30:
;USB_Driver.c,142 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,143 :: 		case 'y':
L_USB_CheckIn31:
;USB_Driver.c,144 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,145 :: 		case 'z':
L_USB_CheckIn32:
;USB_Driver.c,146 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,150 :: 		default:
L_USB_CheckIn33:
;USB_Driver.c,151 :: 		USB_PutQueue("Unknown command\r\n");
MOVW	R0, #lo_addr(?lstr4_USB_Driver+0)
MOVT	R0, #hi_addr(?lstr4_USB_Driver+0)
PUSH	(R0)
BL	_USB_PutQueue+0
ADD	SP, SP, #4
;USB_Driver.c,153 :: 		BufNum = GetBuffer();         // Get a free buffer
BL	_GetBuffer+0
STR	R0, [SP, #4]
;USB_Driver.c,154 :: 		(void)sprintf(BufNum,"%c\r\n",readbuff[0]);
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
PUSH	(R0)
MOVW	R0, #lo_addr(?lstr_5_USB_Driver+0)
MOVT	R0, #hi_addr(?lstr_5_USB_Driver+0)
PUSH	(R0)
LDR	R0, [SP, #12]
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;USB_Driver.c,155 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
PUSH	(R0)
BL	_USB_PutQueue+0
ADD	SP, SP, #4
;USB_Driver.c,156 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,157 :: 		}
L_USB_CheckIn5:
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #97
IT	EQ
BEQ	L_USB_CheckIn7
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #98
IT	EQ
BEQ	L_USB_CheckIn8
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #99
IT	EQ
BEQ	L_USB_CheckIn9
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #100
IT	EQ
BEQ	L_USB_CheckIn10
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #101
IT	EQ
BEQ	L_USB_CheckIn11
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #102
IT	EQ
BEQ	L_USB_CheckIn12
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #103
IT	EQ
BEQ	L_USB_CheckIn13
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #104
IT	EQ
BEQ	L_USB_CheckIn14
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #105
IT	EQ
BEQ	L_USB_CheckIn15
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #106
IT	EQ
BEQ	L_USB_CheckIn16
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #107
IT	EQ
BEQ	L_USB_CheckIn17
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #108
IT	EQ
BEQ	L_USB_CheckIn18
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #109
IT	EQ
BEQ	L_USB_CheckIn19
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #110
IT	EQ
BEQ	L_USB_CheckIn20
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #111
IT	EQ
BEQ	L_USB_CheckIn21
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #112
IT	EQ
BEQ	L_USB_CheckIn22
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #113
IT	EQ
BEQ	L_USB_CheckIn23
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #114
IT	EQ
BEQ	L_USB_CheckIn24
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #115
IT	EQ
BEQ	L_USB_CheckIn25
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #116
IT	EQ
BEQ	L_USB_CheckIn26
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #117
IT	EQ
BEQ	L_USB_CheckIn27
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #118
IT	EQ
BEQ	L_USB_CheckIn28
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #119
IT	EQ
BEQ	L_USB_CheckIn29
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #120
IT	EQ
BEQ	L_USB_CheckIn30
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #121
IT	EQ
BEQ	L_USB_CheckIn31
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #122
IT	EQ
BEQ	L_USB_CheckIn32
IT	AL
BAL	L_USB_CheckIn33
L_USB_CheckIn6:
;USB_Driver.c,158 :: 		}
L_USB_CheckIn4:
;USB_Driver.c,159 :: 		}
L_end_USB_CheckIn:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _USB_CheckIn
